#|
 This file is a part of cl-markless
 (c) 2018 Shirakumo http://tymoon.eu (shinmera@tymoon.eu)
 Author: Nicolas Hafner <shinmera@tymoon.eu>
|#

(in-package #:org.shirakumo.markless)

(defun make-color-table (entries)
  (let ((table (make-hash-table :test 'equalp)))
    (loop for (name (r g b)) on entries by #'cddr
          do (setf (gethash (string name) table)
                   (make-instance 'components:color-option
                                  :red r :green g :blue b)))
    table))

(defparameter *color-table*
  (make-color-table
   '(indian-red (205 92 92)
     light-coral (240 128 128)
     salmon (250 128 114)
     dark-salmon (233 150 122)
     light-salmon (255 160 122)
     crimson (220 20 60)
     red (255 0 0)
     firebrick (178 34 34)
     dark-red (139 0 0)
     pink (255 192 203)
     light-pink (255 182 193)
     hot-pink (255 105 180)
     deep-pink (255 20 147)
     medium-violet-red (199 21 133)
     pale-violet-red (219 112 147)
     light-salmon (255 160 122)
     coral (255 127 80)
     tomato (255 99 71)
     orange-red (255 69 0)
     dark-orange (255 140 0)
     orange (255 165 0)
     gold (255 215 0)
     yellow (255 255 0)
     light-yellow (255 255 224)
     lemon-chiffon (255 250 205)
     light-goldenrod-yellow (250 250 210)
     papayawhip (255 239 213)
     moccasin (255 228 181)
     peachpuff (255 218 185)
     pale-goldenrod (238 232 170)
     khaki (240 230 140)
     dark-khaki (189 183 107)
     lavender (230 230 250)
     thistle (216 191 216)
     plum (221 160 221)
     violet (238 130 238)
     orchid (218 112 214)
     fuchsia (255 0 255)
     magenta (255 0 255)
     medium-orchid (186 85 211)
     medium-purple (147 112 219)
     rebecca-purple (102 51 153)
     blue-violet (138 43 226)
     dark-violet (148 0 211)
     dark-orchid (153 50 204)
     dark-magenta (139 0 139)
     purple (128 0 128)
     indigo (75 0 130)
     slate-blue (106 90 205)
     dark-slate-blue (72 61 139)
     medium-slate-blue (123 104 238)
     green-yellow (173 255 47)
     chartreuse (127 255 0)
     lawn-green (124 252 0)
     lime (0 255 0)
     lime-green (50 205 50)
     pale-green (152 251 152)
     light-green (144 238 144)
     medium-spring-green (0 250 154)
     spring-green (0 255 127)
     medium-sea-green (60 179 113)
     sea-green (46 139 87)
     forest-green (34 139 34)
     green (0 128 0)
     dark-green (0 100 0)
     yellow-green (154 205 50)
     olive-drab (107 142 35)
     olive (128 128 0)
     dark-olive-green (85 107 47)
     medium-aquamarine (102 205 170)
     dark-sea-green (143 188 139)
     light-sea-green (32 178 170)
     dark-cyan (0 139 139)
     teal (0 128 128)
     aqua (0 255 255)
     cyan (0 255 255)
     light-cyan (224 255 255)
     pale-turquoise (175 238 238)
     aquamarine (127 255 212)
     turquoise (64 224 208)
     medium-turquoise (72 209 204)
     dark-turquoise (0 206 209)
     cadet-blue (95 158 160)
     steel-blue (70 130 180)
     light-steel-blue (176 196 222)
     powder-blue (176 224 230)
     light-blue (173 216 230)
     sky-blue (135 206 235)
     light-sky-blue (135 206 250)
     deep-sky-blue (0 191 255)
     dodger-blue (30 144 255)
     cornflower-blue (100 149 237)
     medium-slate-blue (123 104 238)
     royal-blue (65 105 225)
     blue (0 0 255)
     medium-blue (0 0 205)
     dark-blue (0 0 139)
     navy (0 0 128)
     midnight-blue (25 25 112)
     cornsilk (255 248 220)
     blanched-almond (255 235 205)
     bisque (255 228 196)
     navajo-white (255 222 173)
     wheat (245 222 179)
     burlywood (222 184 135)
     tan (210 180 140)
     rosy-brown (188 143 143)
     sandy-brown (244 164 96)
     goldenrod (218 165 32)
     dark-goldenrod (184 134 11)
     peru (205 133 63)
     chocolate (210 105 30)
     saddle-brown (139 69 19)
     sienna (160 82 45)
     brown (165 42 42)
     maroon (128 0 0)
     white (255 255 255)
     snow (255 250 250)
     honeydew (240 255 240)
     mintcream (245 255 250)
     azure (240 255 255)
     alice-blue (240 248 255)
     ghost-white (248 248 255)
     white-smoke (245 245 245)
     seashell (255 245 238)
     beige (245 245 220)
     oldlace (253 245 230)
     floral-white (255 250 240)
     ivory (255 255 240)
     antique-white (250 235 215)
     linen (250 240 230)
     lavenderblush (255 240 245)
     mistyrose (255 228 225)
     gainsboro (220 220 220)
     light-gray (211 211 211)
     silver (192 192 192)
     dark-gray (169 169 169)
     gray (128 128 128)
     dim-gray (105 105 105)
     light-slate-gray (119 136 153)
     slate-gray (112 128 144)
     dark-slate-gray (47 79 79)
     black (0 0 0))))
